-------------------------------------------------
--  This file has been generated automatically
--  by IDLAC (http://libre.adacore.com/polyorb/)
--
--  Do NOT hand-modify this file, as your
--  changes will be lost when you re-run the
--  IDL to Ada compiler.
-------------------------------------------------
pragma Style_Checks (Off);

with PolyORB.Utils.Strings;
with PolyORB.Initialization;
pragma Elaborate_All (PolyORB.Initialization);
with PolyORB.CORBA_P.Domain_Management;
with PolyORB.CORBA_P.IR_Hooks;
with CORBA.Object.Helper;
with CORBA.ORB;
with CORBA.NVList;
with CORBA.ServerRequest;
with Suma.Impl;
with CORBA;
pragma Elaborate_All (CORBA);
with PortableServer;
pragma Elaborate_All (PortableServer);
with PolyORB.CORBA_P.Exceptions;

--  Time
--  with Measure_Times_Ada_Std; use Measure_Times_Ada_Std;

package body Suma.Skel is

   --  Skeleton subprograms

   function Servant_Is_A (Obj : PortableServer.Servant) return Boolean;

   function Servant_Is_A (Obj : PortableServer.Servant) return Boolean is
   begin
      return Obj.all in Suma.Impl.Object'Class;
   end Servant_Is_A;

   procedure Invoke
     (Self    : PortableServer.Servant;
      Request : in CORBA.ServerRequest.Object_Ptr)
   is
      Operation  : constant Standard.String :=
         CORBA.To_Standard_String
           (CORBA.ServerRequest.Operation (Request.all));
      Arg_List_ : CORBA.NVList.Ref;
   begin
      --  Measure Upcall Skeleton (Id = 4)
      --  Take_Measure_Start(4);

      CORBA.ORB.Create_List (0, Arg_List_);
      if Operation = "_is_a" then
         declare
            Type_Id            : CORBA.String;
            Arg_Name__Type_Id : constant CORBA.Identifier :=
               CORBA.To_CORBA_String ("Type_Id");
            Argument__Type_Id : CORBA.Any                 :=
               CORBA.To_Any (Type_Id);

            Result_ : CORBA.Boolean;
         begin
            CORBA.NVList.Add_Item
              (Arg_List_,
               Arg_Name__Type_Id,
               Argument__Type_Id,
               CORBA.ARG_IN);

            CORBA.ServerRequest.Arguments (Request, Arg_List_);

            begin
            --  Convert arguments from their Any

               Type_Id := CORBA.From_Any (Argument__Type_Id);

               --  Call implementation
               Result_ := Suma.Is_A (CORBA.To_Standard_String (Type_Id));
            end;

            -- Set Result

            CORBA.ServerRequest.Set_Result (Request, CORBA.To_Any (Result_));
            return;
         end;

      elsif Operation = "_interface" then

         CORBA.ServerRequest.Arguments (Request, Arg_List_);

         CORBA.ServerRequest.Set_Result
           (Request,
            CORBA.Object.Helper.To_Any
               (CORBA.Object.Ref (
            PolyORB.CORBA_P.IR_Hooks.Get_Interface_Definition
  (CORBA.To_CORBA_String (Repository_Id)))));

         return;

      elsif Operation = "_domain_managers" then

         CORBA.ServerRequest.Arguments (Request, Arg_List_);

         CORBA.ServerRequest.Set_Result
           (Request,
            PolyORB.CORBA_P.Domain_Management.Get_Domain_Managers (Self));

         return;

      elsif Operation = "SumaNum" then

         declare
            x            : CORBA.Long;
            Arg_Name__x : constant CORBA.Identifier :=
               CORBA.To_CORBA_String ("x");
            Argument__x : CORBA.Any                 :=
               CORBA.Internals.Get_Empty_Any (CORBA.TC_Long);

            y            : CORBA.Long;
            Arg_Name__y : constant CORBA.Identifier :=
               CORBA.To_CORBA_String ("y");
            Argument__y : CORBA.Any                 :=
               CORBA.Internals.Get_Empty_Any (CORBA.TC_Long);

            Result_ : CORBA.Long;
         begin
            CORBA.NVList.Add_Item
              (Arg_List_,
               Arg_Name__x,
               Argument__x,
               CORBA.ARG_IN);
            CORBA.NVList.Add_Item
              (Arg_List_,
               Arg_Name__y,
               Argument__y,
               CORBA.ARG_IN);

            CORBA.ServerRequest.Arguments (Request, Arg_List_);

            begin
            --  Convert arguments from their Any

               x := CORBA.From_Any (Argument__x);
               y := CORBA.From_Any (Argument__y);

               --  Measure Upcall Skeleton (Id = 4)
               --                 Take_Measure_Stop (4);
               --                 Store_Measure(4);

               --  Call implementation
               Result_ :=
                  Suma.Impl.SumaNum
                    (Suma.Impl.Object'Class (Self.all)'Access,
                     x,
                     y);
            end;

            -- Set result

            CORBA.ServerRequest.Set_Result (Request, CORBA.To_Any (Result_));
            return;
         end;

      else
         CORBA.Raise_Bad_Operation (CORBA.Default_Sys_Member);
      end if;
   exception
      when E : others =>
         begin
            CORBA.ServerRequest.Set_Exception
              (Request,
               CORBA.Internals.To_CORBA_Any
                  (PolyORB.CORBA_P.Exceptions.System_Exception_To_Any (E)));
            return;
         end;
   end Invoke;

   procedure Deferred_Initialization is
   begin
      PortableServer.Internals.Register_Skeleton
        (CORBA.To_CORBA_String (Suma.Repository_Id),
         Servant_Is_A'Access,
         Is_A'Access,
         Invoke'Access);

   end Deferred_Initialization;

begin
   declare
      use PolyORB.Initialization;
      use PolyORB.Initialization.String_Lists;
      use PolyORB.Utils.Strings;
   begin
      Register_Module
        (Module_Info'
        (Name      => +"Suma.Skel",
         Conflicts => Empty,
         Depends   => Empty,
         Provides  => Empty,
         Implicit  => False,
         Shutdown  => null,
         Init      => Deferred_Initialization'Access));
   end;

end Suma.Skel;
